OpenJPEG: auxtrans_manager.c File Reference

OpenJPEG 2.4.0

Data Structures | Macros | Typedefs | Functions
auxtrans_manager.c File Reference
`#include <stdio.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include "auxtrans_manager.h"`
`#include <pthread.h>`

## Data Structures
struct | aux_response_param

## Macros
#define | FCGI_stdout stdout
#define | FCGI_stderr stderr
#define | logstream stderr

## Typedefs
typedef struct aux_response_param | aux_response_param_t

## Functions
auxtrans_param_t | init_aux_transport (int tcp_auxport, int udp_auxport)
| Initialize auxiliary transport server of JPIP server. More...
void | close_aux_transport (auxtrans_param_t auxtrans)
| Close auxiliary transport server of JPIP server. More...
aux_response_param_t * | gene_auxresponse (OPJ_BOOL istcp, auxtrans_param_t auxtrans, const char cid[], void *data, OPJ_SIZE_T datalen, OPJ_SIZE_T maxlenPerFrame)
void | delete_auxresponse (aux_response_param_t **auxresponse)
void * | aux_streaming (void *arg)
void | send_responsedata_on_aux (OPJ_BOOL istcp, auxtrans_param_t auxtrans, const char cid[], void *data, OPJ_SIZE_T datalen, OPJ_SIZE_T maxlenPerFrame)
| Send response data on aux transport. More...
OPJ_BOOL | identify_cid (SOCKET connected_socket, char refcid[], FILE *fp)
| Identify cid sent from client. More...
OPJ_BOOL | recv_ack (SOCKET connected_socket, void *data)

## Macro Definition Documentation

## ◆ FCGI_stderr

#define FCGI_stderr stderr

## ◆ FCGI_stdout

#define FCGI_stdout stdout

## ◆ logstream

#define logstream stderr

## Typedef Documentation

## ◆ aux_response_param_t

typedef struct aux_response_param aux_response_param_t

## Function Documentation

## ◆ aux_streaming()

void * aux_streaming | ( | void * | arg | ) |

References accept_socket(), aux_response_param::cid, close_socket(), aux_response_param::data, aux_response_param::datalen, delete_auxresponse(), FCGI_stderr, identify_cid(), aux_response_param::listensock, aux_response_param::maxlenPerFrame, opj_free(), opj_malloc(), recv_ack(), and send_stream().

Referenced by send_responsedata_on_aux().

## ◆ close_aux_transport()

void close_aux_transport | ( | auxtrans_param_t | auxtrans | ) |

Close auxiliary transport server of JPIP server.

auxiliary response parameters

References close_socket(), auxtrans_param::tcplistensock, and auxtrans_param::udplistensock.

## ◆ delete_auxresponse()

void delete_auxresponse | ( | aux_response_param_t ** | auxresponse | ) |

References opj_free().

Referenced by aux_streaming().

## ◆ gene_auxresponse()

aux_response_param_t * gene_auxresponse | ( | OPJ_BOOL | istcp,
|  | auxtrans_param_t | auxtrans,
|  | const char | cid[],
|  | void * | data,
|  | OPJ_SIZE_T | datalen,
|  | OPJ_SIZE_T | maxlenPerFrame
| ) |  |

References aux_response_param::cid, aux_response_param::data, aux_response_param::datalen, aux_response_param::listensock, aux_response_param::maxlenPerFrame, opj_malloc(), auxtrans_param::tcplistensock, and auxtrans_param::udplistensock.

Referenced by send_responsedata_on_aux().

## ◆ identify_cid()

OPJ_BOOL identify_cid | ( | SOCKET | connected_socket,
|  | char | refcid[],
|  | FILE * | fp
| ) |  |

Identify cid sent from client.

Parameters

  [in] | connected_socket | file descriptor of the connected socket
  [in] | refcid | refenrece channel ID
  [in] | fp | file pointer for log of aux stream

Returns
  true if identified, false otherwise

References OPJ_FALSE, opj_free(), OPJ_TRUE, and receive_string().

Referenced by aux_streaming().

## ◆ init_aux_transport()

auxtrans_param_t init_aux_transport | ( | int | tcp_auxport,
|  | int | udp_auxport
| ) |  |

Initialize auxiliary transport server of JPIP server.

Parameters

  [in] | tcp_auxport | opening tcp auxiliary port ( 0 not to open, valid No. 49152-65535)
  [in] | udp_auxport | opening udp auxiliary port ( 0 not to open, valid No. 49152-65535)

Returns
  initialized transport parameters

References open_listeningsocket(), auxtrans_param::tcpauxport, auxtrans_param::tcplistensock, auxtrans_param::udpauxport, and auxtrans_param::udplistensock.

## ◆ recv_ack()

OPJ_BOOL recv_ack | ( | SOCKET | connected_socket,
|  | void * | data
| ) |  |

References OPJ_FALSE, opj_free(), OPJ_TRUE, and receive_stream().

Referenced by aux_streaming().

## ◆ send_responsedata_on_aux()

void send_responsedata_on_aux | ( | OPJ_BOOL | istcp,
|  | auxtrans_param_t | auxtrans,
|  | const char | cid[],
|  | void * | data,
|  | OPJ_SIZE_T | length,
|  | OPJ_SIZE_T | maxlenPerFrame
| ) |  |

Send response data on aux transport.

Parameters

  [in] | istcp | true if tcp, false if udp
  [in] | auxtrans | available transport parameters
  [in] | cid | channel ID
  [in] | data | sending data
  [in] | length | length of data
  [in] | maxlenPerFrame | maximum data length to send per frame

References aux_streaming(), FCGI_stderr, gene_auxresponse(), and auxtrans_param::tcplistensock.

OPJ_BYTE
unsigned char OPJ_BYTE
Definition: openjpeg.h:117
opj_codestream_info::tw
int tw
number of tiles in X
Definition: openjpeg.h:867
opj_stream_write_data
OPJ_SIZE_T opj_stream_write_data(opj_stream_private_t *p_stream, const OPJ_BYTE *p_buffer, OPJ_SIZE_T p_size, opj_event_mgr_t *p_event_mgr)
Writes some bytes to the stream.
Definition: cio.c:385
MAX
#define MAX(a, b)
Definition: tpix_manager.c:38
OPJ_OFF_T
int64_t OPJ_OFF_T
Definition: openjpeg.h:130
opj_stream_skip
OPJ_OFF_T opj_stream_skip(opj_stream_private_t *p_stream, OPJ_OFF_T p_size, opj_event_mgr_t *p_event_mgr)
Skips a number of bytes from the stream.
Definition: cio.c:593
opj_stream_seek
OPJ_BOOL opj_stream_seek(opj_stream_private_t *p_stream, OPJ_OFF_T p_size, struct opj_event_mgr *p_event_mgr)
Seeks a number of bytes from the stream.
Definition: cio.c:641
opj_event_mgr
Message handler object used for.
Definition: event.h:50
opj_stream_tell
OPJ_OFF_T opj_stream_tell(const opj_stream_private_t *p_stream)
Tells the byte offset on the stream (similar to ftell).
Definition: cio.c:579
opj_stream_private
Byte input-output stream.
Definition: cio.h:81
opj_write_tpix
int opj_write_tpix(int coff, opj_codestream_info_t cstr_info, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition: tpix_manager.c:60
opj_includes.h
opj_write_tpixfaix
int opj_write_tpixfaix(int coff, int compno, opj_codestream_info_t cstr_info, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition: tpix_manager.c:86
opj_tp_info::tp_start_pos
int tp_start_pos
start position of tile part
Definition: openjpeg.h:791
opj_tp_info
Index structure : Information concerning tile-parts.
Definition: openjpeg.h:789
opj_tile_info::num_tps
int num_tps
number of tile parts
Definition: openjpeg.h:837
JPIP_TPIX
#define JPIP_TPIX
Definition: indexbox_manager.h:48
opj_codestream_info::tile
opj_tile_info_t * tile
information regarding tiles inside image
Definition: openjpeg.h:891
opj_codestream_info
Index structure of the codestream.
Definition: openjpeg.h:845
OPJ_UINT32
uint32_t OPJ_UINT32
Definition: openjpeg.h:126
opj_tile_info::tp
opj_tp_info_t * tp
information concerning tile parts
Definition: openjpeg.h:839
JPIP_FAIX
#define JPIP_FAIX
Definition: indexbox_manager.h:46
opj_codestream_info::numdecompos
int * numdecompos
number of decomposition for each component
Definition: openjpeg.h:875
opj_write_bytes
#define opj_write_bytes
Definition: cio.h:64
opj_codestream_info::th
int th
number of tiles in Y
Definition: openjpeg.h:869
opj_tp_info::tp_end_pos
int tp_end_pos
end position of tile part
Definition: openjpeg.h:795
get_num_max_tile_parts
int get_num_max_tile_parts(opj_codestream_info_t cstr_info)
Definition: tpix_manager.c:181